controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider;
use app\models\Ciclista;
use app\models\Lleva;
use app\models\Etapa;
use app\models\Equipo;
use app\models\Puerto;



class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
 /*MOSTRAR ESTADÍSTICAS GENERALES*/
      public function actionGenerales()
    {
        $dataProvider = new ActiveDataProvider([
              'query' => Ciclista::find() ,
          ]);
        
 $grafNumerociclistas = Yii::$app->db->createCommand('SELECT nomequipo, COUNT(*) numero FROM ciclista GROUP BY nomequipo')->queryAll();
          $grafCiclistasetapasganadas = Yii::$app->db->createCommand('SELECT DISTINCT nombre, COUNT(*)numero2 FROM ciclista INNER JOIN etapa USING (dorsal) GROUP BY dorsal;')->queryAll();
          $grafCiclistaspuertosganados = Yii::$app->db->createCommand('SELECT DISTINCT nombre, COUNT(*)numero3 FROM ciclista  INNER JOIN puerto USING (dorsal) GROUP BY dorsal;')->queryAll();
     
 
          /*KMS por etapas*/
          $kmsEtapas= yii:: $app -> db -> createCommand('Select numetapa etapas, kms recorrido from etapa') -> queryAll();
          
                /*Maillot más llevado*/
          $maillotsUsados= yii:: $app -> db -> createCommand('Select color, código, COUNT(*) numero4 from lleva inner join maillot using(código) group by código ') -> queryAll();

          
          
                /*Ciclista que ha ganado más etapas*/
             $ciclistaMasEstapas=yii:: $app -> db -> createCommand('SELECT nombre ganador , dorsal, COUNT(*) total FROM ciclista 
INNER JOIN etapa USING(dorsal) 
GROUP BY dorsal 
HAVING COUNT(*) = 
(SELECT MAX(total) FROM (SELECT dorsal, COUNT(*) total FROM etapa GROUP BY dorsal )c1)  ') ->queryALL();
          
                /*Ciclista que ha ganado más puertos*/
        $ciclistaMasPuertos=yii:: $app -> db -> createCommand('SELECT nombre ganadorPuerto , dorsal, COUNT(*) total1 FROM ciclista 
INNER JOIN puerto USING(dorsal) 
GROUP BY dorsal 
HAVING COUNT(*) = 
(SELECT MAX(total1) FROM (SELECT dorsal, COUNT(*) total1 FROM puerto GROUP BY dorsal )c1) ') ->queryALL();
        
        
                /*Altura de los puerto*/
          $alturaPuerto= yii:: $app -> db -> createCommand('Select nompuerto nombrePuerto, altura from puerto') -> queryAll();
     
          /*edad media de los ciclistas*/
        
        $edadMedia=yii::$app->db->createCommand('Select AVG(edad) edadMedia from ciclista')->queryALL();
        
        /*etapas circulares*/
        $etapasCirculares=yii::$app->db->createCommand('Select numetapa numeroEtapa, salida from etapa where salida=llegada')->queryALL();
        
        /*victorias de etapa por equipos*/
        $victoriaEquipos=yii::$app->db->createCommand('SELECT nomequipo, COUNT(*) victorias FROM ciclista INNER JOIN etapa  USING(dorsal) GROUP BY nomequipo')->queryALL();
        
         /*victorias puerto por equipos*/
        $victoriaEquiposPuerto=yii::$app->db->createCommand('SELECT nomequipo, COUNT(*) victoriasPuertos FROM ciclista INNER JOIN puerto  USING(dorsal) GROUP BY nomequipo')->queryALL();
        
        /*Edad de los ciclistas*/
        $edadCiclistas=yii::$app->db->createCommand('Select distinct edad, count(*) edadCiclista from ciclista group by edad')->queryALL();
          
        
        /*Premio maillots*/
        $premiosMaillot=yii::$app->db->createCommand('Select premio, código from maillot')->queryALL();
        return $this->render('general',[
            
          "resultado"=>$dataProvider,
            'grafNumerociclistas'=>$grafNumerociclistas,
           'grafCiclistasetapasganadas'=>$grafCiclistasetapasganadas,
           'grafCiclistaspuertosganados'=>$grafCiclistaspuertosganados,
            'ciclistaMasEstapas'=> $ciclistaMasEstapas,
            'ciclistaMasPuertos'=>$ciclistaMasPuertos,
            'edadMedia'=>$edadMedia,
            'kmsEtapas'=>$kmsEtapas,
            'maillotsUsados'=>$maillotsUsados,
            'alturaPuerto' =>$alturaPuerto,
            'etapasCirculares'=>$etapasCirculares,
            'edadCiclistas'=> $edadCiclistas,
            'premiosMaillot'=>$premiosMaillot,
            'victoriaEquipos'=>$victoriaEquipos,
            'victoriaEquiposPuerto'=>$victoriaEquiposPuerto,
     ]);
          

        
    }
            
        /*MOstrar información de los equipos*/
      public function actionEquipos()
    {
          $dataProvider = new ActiveDataProvider([
              'query' => Equipo::find() ,
          ]);
        return $this->render('equipos',[
            'dataProvider' => $dataProvider,
            

        ]);
    }


     /*ESTADÍSTICAS Por cada equipo*/
      public function actionEquiposciclistas($nomequipo)
    {
          $dataProvider = new ActiveDataProvider([
              'query' => Ciclista::find() -> where("nomequipo= '$nomequipo' "),
          ]);
          
               /*Mostrar número de etapas  ganados*/
            $ciclistasPorEquipo =  Ciclista:: find() -> select('nombre') -> where("nomequipo= ' $nomequipo' ")->scalar();
            
    return $this->render('equiposciclista',[
           'equiposciclistas'=>$dataProvider,
        'ciclistasPorEquipo'=>$ciclistasPorEquipo,
       
   
        ]);
    }
    
        /*MOSTRAR ESTADÍSTICAS Ciclista*/
      public function actionCiclistas()
    {
          $dataProvider = new ActiveDataProvider([
              'query' => Ciclista::find() ,
          ]);
          
        return $this->render('ciclistas',[
            "dataProvider" => $dataProvider,

        ]);
    }
     /*ESTADÍSTICAS Por cada ciclista*/
      public function actionEstadisticas($dorsal)
    {
           $dataProvider = new ActiveDataProvider([
              'query' => Ciclista::find() -> where("dorsal= '$dorsal' "),
          ]);
           
                /*Mostrar número de etapas  ganados*/
            $totales =  Etapa:: find() -> select('count(*) total') -> where("dorsal= ' $dorsal' ")->scalar();
            
            /*Mostrar número de puertos ganados*/
            $puertos = Puerto:: find() -> select('count(*) total') -> where("dorsal= ' $dorsal' ")->scalar();
            
                 /*Mostrar número de maillots ganados*/
             $maillots = Lleva:: find() -> select('count(*) total') -> where("dorsal= ' $dorsal' ")->scalar();
             
                  /*Mostrar el total de los premios ganados*/
            $query = new \yii\db\Query;
            $query  -> select('sum(premio) cantidad') ->from ('lleva')  ->join('INNER join', 'maillot', 'maillot.código=lleva.código') -> where("dorsal= ' $dorsal' ") -> groupby('dorsal');
            $premio = $query->scalar();
          	
                
              $premio  = ($premio  == null) ? 0 : $premio ;
              
 
       
          
        
        return $this->render('resultado',[
            "resultados"=>$dataProvider,
            "totales" => $totales,
            "puertos" => $puertos,
            "maillots"=>$maillots,
            'premio'=>$premio,
           
   
        ]);
    }
    
 
    
    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    
     public function actionInformacion()
    {
        return $this->render('informacion');
    }
}

views/site/_ciclistas.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;

?>


    
    <div class="col-sm-12">
            <div class="card minimo">
              <div class="card-body">
                 <h5 class="card-title"><?=$model -> nombre?></h5>
                 <p class="card-text"><?="Dorsal del ciclista: ". $model -> dorsal?></p>
                 <?= Html::a('Ver más',['site/estadisticas', 'dorsal'=>$model -> dorsal, ], ['class' => 'btn btn-primary btn-block'] ) ?>
              </div>
            </div>
        </div>

     

views/site/_equipos.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;



?>


    
    <div class="col-sm-12">
            <div class="card minimo">
              <div class="card-body">
                 <h5 class="card-title"><?=$model -> nomequipo?></h5>
                 <p class="card-text">  Dir. <?=$model ->director?></p>
                 <?= Html::a('Ver más',['site/equiposciclistas', 'nomequipo'=>$model -> nomequipo, ], ['class' => 'btn btn-primary btn-block'] ) ?>
              </div>
            </div>
        </div>

views/site/_equiposciclistas.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;


?>
<p> </p>


        <div class="col-sm-12">
            <div class="card ciclistasequipo">
              
                        <div class="card-body">
                           <h5 class="card-title"> <?=$model -> nombre?>  </h5>
                            <?= Html::a('Ver más',['site/estadisticas', 'dorsal'=>$model -> dorsal, ], ['class' => 'btn btn-primary btn-block'] ) ?>
                        </div>
                      </div>
                  </div>
            
        

views/site/_resultado.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
use yii\web\JsExpression;
use yii\base\BaseObjec;
use miloschuman\highcharts\Highcharts;
 $this->title= 'Ciclista';


?>
<script src="https://code.highcharts.com/highcharts.js"></script>
<script src="https://code.highcharts.com/modules/exporting.js"></script>
<script src="https://code.highcharts.com/modules/export-data.js"></script>
<script src="https://code.highcharts.com/modules/accessibility.js"></script>
<h1><?=$model -> nombre?></h1>
<p>  <?="Dorsal ". $model -> dorsal?>, <?=$model -> edad?> años, <?="Ciclista de ". $model -> nomequipo?></p>
        <div class="row">
            <div class="col-sm-6 col-md-3">
                      <div class="card ciclistas">
                        <div class="card-body">
                           <h3 class="card-title"> <?=$totales ?></h3>
                           <p class="card-text">Etapas Ganadas
                                   </p>
                        </div>
                      </div>
                  </div>
            <div class="col-sm-6 col-md-3">
                      <div class="card ciclistas">
                        <div class="card-body">
                           <h3 class="card-title"><?=$puertos ?></h3>
                           <p class="card-text">Puertos Ganados</p>

                        </div>
                      </div>
                  </div>
            
            <div class="col-sm-6 col-md-3">
                      <div class="card ciclistas">
                        <div class="card-body">
                           <h3 class="card-title"><?=$maillots?></h3>
                           <p class="card-text">Maillot Ganados</p>

                        </div>
                      </div>
                  </div>
            
       <div class="col-sm-6 col-md-3">
                      <div class="card ciclistas">
                        <div class="card-body">
                           <h3 class="card-title"><?=$premio?>€</h3>
                           <p class="card-text">Premio Ganado</p>

                        </div>
                      </div>
                  </div>
        </div>

 

views/site/ciclistas.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
use  yii\widgets\ListView;
$this->title = 'Ciclistas';

?>


<div class="jumbotron ">
          <h1><?= $this->title?></h1>
                 
        <?=   ListView::widget([
            'dataProvider' => $dataProvider,
           'itemView' => '_ciclistas',
            'layout'=>"\n{items}{pager}",
            
        ]);
?>
          
      </div>
        
 

views/site/contact.php
<?php

/** @var yii\web\View $this */
/** @var yii\bootstrap4\ActiveForm $form */
/** @var app\models\ContactForm $model */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/equipos.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
use  yii\widgets\ListView;
 $this->title= 'Equipos';

?>


<div class="jumbotron ">
          <h1><?= $this->title?></h1>
                 
        <?=   ListView::widget([
            'dataProvider' => $dataProvider,
           'itemView' => '_equipos',
            'layout'=>"\n{items}{pager}",
           
        ]);
?>
          
      </div>
        

views/site/equiposciclista.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
use  yii\widgets\ListView;
 $this->title= 'Ciclistas';


?>


<div class="jumbotron">
    
    <?=   ListView::widget([
            'dataProvider' => $equiposciclistas,
           'itemView' => '_equiposciclistas',
          'layout'=>'{items}',
          'viewParams' => [  'ciclistasPorEquipo'=>$ciclistasPorEquipo],

        ]);
?>
   
  
    </div>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
$this->title = 'Inicio';

?>

<div id="fondo">
    <h1>Vuelta Ciclista España</h1>
    
   
    <div class="container text-center">
  <div class="row justify-content-evenly align-items-center">
    <div class="col-7"> <h2>Información General</h2>
       <p>  <h6>EDICIÓN: 49; MADRID-VALLADOLID DEL 25/04/1994 AL 15/05/1994</h6></p>
          
     <p>  <?= Html::img('@web/img/cartel94.jpg', ['alt' => 'My logo']) ?> La 49ª edición, la del adiós de Pedro DELGADO, comenzó con pocas posibilidades para los españoles, ya que Perico estaba en el final de su carrera deportiva 
        y los corredores jóvenes todavía eran demasiado inexpertos para optar al triunfo final, por lo que el dedo de los entendidos señaló a los suizos Alex ZULLE y 
        Tony ROMINGER como grandes favoritos para el triunfo final.</p>
        <p> <?= Html::a('Ver más',['site/informacion'], ['class' => 'btn btn-info btn-lg'] ) ?></p>
    </div>
      <div class="col-1">    </div>
    <div class="col-4 justify-content-center">
      <p> <?= Html::a('Estadísticas Generales',['site/generales'], ['class' => 'btn btn-info btn-lg btn-block'] ) ?></p>
    <p> <?= Html::a('Estadísticas De los Ciclistas',['site/ciclistas'], ['class' => 'btn btn-info btn-lg btn-block'] ) ?></p>
     <p> <?= Html::a('Equipos de la Vuelta España',['site/equipos'], ['class' => 'btn btn-info btn-lg btn-block'] ) ?></p>
    </div>
    
  </div>
</div>
    <section>
        
    </section>
    
    

</div>

views/site/informacion.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
$this->title = 'Información general';

?>

<div class="jumbotron">
    <h1><?=$this->title?></h1>
    
    <p>  La 49ª edición, la del adiós de Pedro DELGADO, comenzó con pocas posibilidades para los españoles, ya que Perico estaba en el final de su carrera deportiva y los corredores jóvenes todavía eran demasiado inexpertos para optar al triunfo final, por lo que el dedo de los entendidos señaló a los suizos Alex ZULLE y Tony ROMINGER como grandes favoritos para el triunfo final.</p>
        
    <p>ROMINGER demostró su fortaleza y desde la primera etapa de montaña, en Sierra Nevada, dejó claro quién era el hombre a batir. Atacó y ZULLE no fue capaz de seguirle, dejando ver que no estaba al mismo nivel que había exhibido el año anterior.</p>
        
    <p>Tras la contrarreloj disputada en Benidorm, ROMINGER aventajaba ya en cuatro minutos a Mikel ZARRABEITIA, segundo clasificado en la general.</p>
    
    <p>El único ataque serio que tuvo que soportar el suizo se produjo en la subida a Cerler, cuando ZARRABEITIA atacó a seis kilómetros del final, pero tuvo que desistir ante la fenomenal respuesta de ROMINGER, quien no estaba dispuesto a dejar escapar su tercer triunfo consecutivo en la ronda española.</p>
        
    <p>Las siguientes etapas transcurrieron por los mismos cauces. ROMINGER y ZARRABEITIA se mostraron intratables en los primeros puestos, ZULLE vio cómo aumentaba día a día su ventaja, mientras que DELGADO, lleno de experiencia y sabiduría, administró sus fuerzas para conseguir un lugar en el podio, objetivo que cumplió</p>
</div>

views/site/login.php
<?php

/** @var yii\web\View $this */
/** @var yii\bootstrap4\ActiveForm $form */
/** @var app\models\LoginForm $model */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n{input}\n{error}",
            'labelOptions' => ['class' => 'col-lg-1 col-form-label mr-lg-3'],
            'inputOptions' => ['class' => 'col-lg-3 form-control'],
            'errorOptions' => ['class' => 'col-lg-7 invalid-feedback'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"offset-lg-1 col-lg-3 custom-control custom-checkbox\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="offset-lg-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="offset-lg-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/resultado.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
use  yii\widgets\ListView;
 $this->title= 'Ciclistas';

?>


<div class="jumbotron">
    <?=   ListView::widget([
            'dataProvider' => $resultados,
           'itemView' => '_resultado',
          'layout'=>"{items}",
          'viewParams' => ['totales' => $totales, 'puertos'=>$puertos, 'maillots'=>$maillots, 'premio'=>$premio,  ],

        ]);
?>
    
  
    </div>